<?php
/**
 * Plugin Acces restreints Giseh 
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/presentation');
include_spip('inc/filtres');

function exec_ciar_config(){

	if (!autoriser('configurer', 'configuration')) {
		include_spip('inc/minipres');
		echo minipres();
	} else {
	
		$commencer_page = charger_fonction('commencer_page', 'inc');
		echo $commencer_page(_T('ciar:titre_liste_rubriques'), "configuration", "configuration");
		
		echo "<br />\n";
		echo gros_titre(_T('ciar:titre_liste_rubriques'),'', false);
		
		echo debut_gauche('', true);
		$ciar_navigation = charger_fonction('ciar_navigation', 'configuration');
	  	echo $ciar_navigation();
	
		echo creer_colonne_droite('', true);
		echo debut_droite('', true);
	
		echo ciar_avertissement();
		
		echo ciar_liste_acces_restreint();
		echo ciar_liste_acces_indiv2();
	
	
		echo fin_gauche(), fin_page();
	}
}


function ciar_liste_acces_restreint() {
	
    $texte = "";

	$exec = "rubrique";
    
	$result = sql_select('rub.*', "spip_rubriques AS rub LEFT JOIN spip_ciar_rubriques_protection AS l ON l.id_rubrique=rub.id_rubrique", "l.acces_restreint='_acces_restreint'","","rub.titre");
	while ($row = sql_fetch($result)) {
		$texte .= "<li><a href='".generer_url_ecrire($exec,"id_rubrique=".$row['id_rubrique'])."'>".$row['titre']."</a></li>\n";
    }
    
    if ($texte) {
		$texte = debut_cadre_relief('',true,'',_T('ciar:ar'))
	    . "<ul class='arial11'>"
	    . $texte
	    . "</ul>\n"
	    . fin_cadre_relief(true);
    }

	return $texte;  
}	


function ciar_liste_acces_indiv() {

    $texte = "";

    $exec = "rubrique";
    
    $gestionnaires = array();
	$result = sql_select('auteurs.id_auteur,auteurs.nom,l.id_rubrique', "spip_auteurs AS auteurs LEFT JOIN spip_ciar_auteurs_acces_rubriques AS l ON l.id_auteur=auteurs.id_auteur", "l.cistatut_auteur_rub='eccma'");
	while ($row = sql_fetch($result)) {
		$gestionnaires[$row['id_rubrique']][]=$row['nom'];
	}
 
	$result = sql_select('rub.*', "spip_rubriques AS rub LEFT JOIN spip_ciar_rubriques_protection AS l ON l.id_rubrique=rub.id_rubrique", "l.acces_restreint='_acces_indiv'");
	while ($row = sql_fetch($result)) {
		if (isset($gestionnaires[$row['id_rubrique']]))
			$gestionnaire = " (".implode(", ",$gestionnaires[$row['id_rubrique']]).")";
		else
			$gestionnaire = "";
		$texte .= "<li><a href='".generer_url_ecrire($exec,"id_rubrique=".$row['id_rubrique'])."'>".$row['titre']."</a>".$gestionnaire."</li>\n";
    }

    if ($texte) {
		$texte = debut_cadre_relief('',true,'',_T('ciar:ari'))
		. _T('ciar:info_gestionnaire')
	    . "<ul class='arial11'>"
	    . $texte
	    . "</ul>\n"
	    . fin_cadre_relief(true);
    }
    
	return $texte;  
}	


function ciar_liste_acces_indiv2() {

    $texte = "";

    $exec = "rubrique";
    
    $gestionnaires = array();
	$result = sql_select('auteurs.id_auteur,auteurs.nom,l.id_rubrique', "spip_auteurs AS auteurs LEFT JOIN spip_ciar_auteurs_acces_rubriques AS l ON l.id_auteur=auteurs.id_auteur", "l.cistatut_auteur_rub='eccma'","","auteurs.nom");
	while ($row = sql_fetch($result)) {
		$gestionnaires[$row['id_rubrique']][]=$row['nom'];
	}
 
	$result = sql_select('rub.*', "spip_rubriques AS rub LEFT JOIN spip_ciar_rubriques_protection AS l ON l.id_rubrique=rub.id_rubrique", "l.acces_restreint='_acces_indiv'","","rub.titre");
	while ($row = sql_fetch($result)) {
		if (isset($gestionnaires[$row['id_rubrique']]))
			$gestionnaire = implode(", ",$gestionnaires[$row['id_rubrique']]);
		else
			$gestionnaire = "";
			
		$texte .= '<tr><td headers="col1"><a href="'.generer_url_ecrire($exec,"id_rubrique=".$row['id_rubrique']).'"><b>'.textebrut(typo($row['titre'])).'</b></a><div>'.ciar_afficher_hierarchie($row['id_rubrique']).'</div></td>';		
		$texte .= '<td headers="col2">'.$gestionnaire.'</td>';
		$texte .= '<td headers="col3">[<a href="'.generer_url_ecrire("ciar_gerer_gestionnaires","id_rubrique=".$row['id_rubrique']).'">'._T('ciar:ajouter_gestionnaire').'</a>]</td></tr>';
    }

    if ($texte) {
		$texte = debut_cadre_relief('',true,'',_T('ciar:ari'))
	    . '<table class="spip" summary="'._T('ciar:ari').'">'
		. '<thead><tr>
			<th width="70%" id="col1">'._T('ciar:ec').'</th>
			<th width="20%" id="col2">'._T('ciar:gestionnaire').'</th>
			<th width="10%" id="col3">'._T('ciar:action').'</th>
			</tr></thead>
			<tbody>'
	    . $texte
	    . "</table>\n"
	    . fin_cadre_relief(true);
    }

	return $texte;
}


function ciar_avertissement() {
	global $spip_lang_right, $spip_lang_left;

	return debut_boite_info(true)
	. "<div class='verdana2' style='text-align: justify'>"
	. _T('ciar:info_fonctionnement1')
	. "</div>"
	. "<div>&nbsp;</div>"
	. "<div class='verdana2' style='text-align: justify'>"
	. _T('ciar:info_fonctionnement2')
	. "</div>"
	. "<div>&nbsp;</div>"
	. "<div class='verdana2' style='text-align: justify'>"
	. _T('ciar:info_fonctionnement3')
	. "</div>"
	. fin_boite_info(true)
	. "<div>&nbsp;</div>";
}

// http://doc.spip.org/@afficher_hierarchie
function ciar_afficher_hierarchie($id_rubrique, $message='',$id_objet=0,$type='',$id_secteur=0,$restreint='') {
	global $spip_lang_left,$spip_lang_right;

	$res = sql_fetsel("id_parent, titre, lang", "spip_rubriques", "id_rubrique=".intval($id_rubrique));
	$id_parent = $res['id_parent'];

	
	$out = "";
	$nav = "";
 	if ($id_objet) {
 		# desactiver le selecteur de rubrique sur le chemin
 		# $nav = chercher_rubrique($message,$id_objet, $id_parent, $type, $id_secteur, $restreint,true);
 		$nav = $nav ?"<div class='none'>$nav</div>":"";
 	}

	$parents = '';
	$style1 = "$spip_lang_left center no-repeat; padding-$spip_lang_left: 15px";
	$style2 = "margin-$spip_lang_left: 15px;";

	$id_rubrique = $id_parent;
	while ($id_rubrique) {

		$res = sql_fetsel("id_parent, titre, lang", "spip_rubriques", "id_rubrique=".intval($id_rubrique));

		if (!$res){  // rubrique inexistante
			$id_rubrique = 0;
			break;
		}

		$id_parent = $res['id_parent'];
		changer_typo($res['lang']);

		$class = (!$id_parent) ? "secteur"
		: (acces_restreint_rubrique($id_rubrique)
		? "admin" : "rubrique");

		$parents = "<em> &gt; </em>"
		. supprimer_numero(typo(sinon($res['titre'], _T('ecrire:info_sans_titre'))))
		. $parents
		. "";

		$id_rubrique = $id_parent;
	}

	$out .= '<div class="small">'._T('info_racine_site') . $parents . "</div>";


 	return $out;
}


?>